#!/usr/bin/perl
# plasticity2 - perl script (2 of 2) that analyses protein similarity searchs
#and clusterize regions of genes which are absent on non-pathogenic bacterium
#to find Putative Pathogenicity Islands.
#
# Written by: Siomar C. Soares, Federal University of Minas Gerais (UFMG), 
#   Laboratory of Celular and Molecular Genetics, Brazil
#
# Date Written: Sep 27, 2010

##################
#@file5 = split ("\n", $positions);
$name = $ARGV[0];
open (IN, "$name.indel");
@file5 = <IN>;
my %beg;
my %end;
my @ordered;
for $i (@file5)	{
	$temp1 .= $i;
		}
@line = split ("\>", $temp1);
for $i1 (@line){
	@line1 = split ("\n", $i1);
	$temp = shift (@line1);
	if ($temp !~ /.+/){next;}
	for $i2 (@line1){
		@line2 = split ("\t", $i2);
		$key=$line2[1];
		$beg->{$key}=$line2[0];
		chomp $line2[5];
		$end->{$key}=$line2[2]."\t".$line2[3]."\t".$line2[4]."\t".$line2[5];
		$key2[$ccc] .= $key; $ccc++;	}
	@ordered = sort {$a <=> $b} @key2;
	#print "\>".$temp."\n";
	$order .= "\>".$temp."\n";
	for $i(@ordered)	{
	#print "$beg->{$i}"."\t"."$i"."\t"."$end->{$i}"."\n";
	$order .= "$beg->{$i}"."\t"."$i"."\t"."$end->{$i}"."\n";
	@key2 = "";
	$ccc =0;
				}		
			}
			
##################

my %pose;
my %posb1;
my %posb2;

@line1 = split ("\>", $order);
for $i1 (@line1){
	@line2 = split ("\n", $i1);
	$temp = shift (@line2);
	if ($temp !~ /.+/){next;}
	#$out .= "\>".$temp."\n";
	$c=1;
	for $i2 (@line2)	{@line3 = split ("\t", $i2); 
		chomp $line3[1];
		chomp $line3[2];
		chomp $line3[0];
		$cds = $line3[0];
		$pose->{$c}=$line3[2];
		$b=$line3[1];
		$posb1->{$c}=$b-3000; 
		$posb2->{$c}=$b+3000; 
		$c++;		}
	$c=1;
	$cc=2;
	$columns=0;
	for $i3 (@line2) {
	$columns++;
			}
	$p=0;
	while ($p <= $columns)	{
		@line4 = split ("\t", $line2[$p]);
		my $begin = $line4[0];
		my $end = $line4[0];
		my $locb = $line4[1];
		chomp $locb;
		my $loce = $line4[2];
		chomp $loce; 
		if (($pose->{$c} > $posb1->{$cc})&&($pose->{$c} < $posb2->{$cc}))	{
		while (($pose->{$c} > $posb1->{$cc})&&($pose->{$c} < $posb2->{$cc}))
			{$p++; @line4 = split ("\t", $line2[$p]); 
			if ($locb > $line4[1]){$locb = $line4[1];}
			if ($loce < $line4[2]){$loce = $line4[2];} 
			$end=$line4[0]; $c++; $cc++;
			}
											}
		else	{$p++; $c++; $cc++;}
		$length = $loce - $locb;
		if ($length > 3000){$out .= "\>".$temp."\t".$begin."\t".$end."\t".$locb."\t".$loce."\n";}
				 }
	}
@line1 = split ("\>", $out);
$out ="";
for $i1 (@line1){
	@line2 = split ("\t", $i1);
	chomp $line2[3];
	chomp $line2[4];
	if ("$line2[3]" !~ "$line2[4]") { $out .= "\>".$i1;}
		}
$temp = "";
@file1 = split ("\>", $out);
$out ="";
@file2 = split ("\>", $temp1);
for $i1 (@file1){
	@line1 = split ("\t", $i1);
	for $i2 (@file2){
	@line2 = split ("\n", $i2);
	$temp = shift (@line2);
	@comp = split ("\t", $temp);
	
	if ($comp[0] eq $line1[0]){
		#$out .= "\>".$i1;
		for $i3 (@line2)		  {
		@line3 = split ("\t", $i3);
			if (($line3[1] >= $line1[5]) && ($line3[2]<=$line1[6]))
				{$out .= $i3."\n";}
						   }	
				 }
			}
       	        }
#print $out;

######################################################
######################################################
######################################################
@file3 = split ("\n", $out);
$order = "";
my %beg;
my %end;
my @ordered;
for $i(@file3)	{@line4 = split ("\t", $i); 
		$key=$line4[4];
		$beg->{$key}=$line4[0]."\t".$line4[1]."\t".$line4[2]."\t".$line4[3];
		chomp $line4[5];
		$end->{$key}=$line4[5];
		}
$ccc=0;
for $i(@file3)	{@line4 = split ("\t", $i); 
		$key[$ccc].=$line4[4]; $ccc++;
		}
@ordered = sort {$a <=> $b} @key;
for $i(@ordered)	{
	$order .= "$beg->{$i}"."\t"."$i"."\t"."$end->{$i}"."\n";
			}

##################

my %pose;
my %posb1;
my %posb2;
my $cc=1;
my @line3;
my $e;
@file1 = split ("\n", $order);
for $i(@file1)	{@line3 = split ("\t", $i); 
		chomp $line3[5];
		chomp $line3[4];
		$pose->{$cc}=$line3[5];
		$b=$line3[4];
		$posb1->{$cc}=$b-1500; 
		$posb2->{$cc}=$b+1500; $cc++;}
$numblines = $cc;

############################
my $end;
my @line4;
$c=1;
$cc=2;
$p = 0;
@line = split ("\n", $order);
$indel1 ="";
while ($c <$numblines){
	@line4 = split ("\t", $line[$p]);
	my $begin = $line4[3];
	my $end = $line4[3];
	my $locb = $line4[4];
	chomp $locb;
	my $loce = $line4[5];
	if (($pose->{$c} > $posb1->{$cc})&&($pose->{$c} < $posb2->{$cc}))	{
		while (($pose->{$c} > $posb1->{$cc})&&($pose->{$c} < $posb2->{$cc}))
		{$p++; @line4 = split ("\t", $line[$p]); 
			if ($locb > $line4[4]){$locb = $line4[4];}
			if ($loce < $line4[5]){$loce = $line4[5];} 
		$end=$line4[3]; $c++; $cc++;}
										}
	else	{$p++; $c++; $cc++;
		}
	chomp $loce; $indel1 .= $begin."\t".$end."\t".$locb."\t".$loce."\n";
			}

################################
$indel2 ="";
my @file= split ("\n", $indel1);
for $i (@file)	{
	@line = split ("\t", $i);
	if ($line[0]!~$line[1]){
		if ($line[3] > $line[2]){
		$indel3 .= $line[0]."\-".$line[1]."\t".$line[2]."\t".$line[3]."\n";}		
		else{$indel3 .= $line[1]."\-".$line[0]."\t".$line[2]."\t".$line[3]."\n";}
				}
		}
################################
$name = $ARGV[0];
open (OUT, ">$name.clusters");
my @file3 = split ("\n", $indel3);
$c=0;
$cc=1;
for $i (@file3){
	@pos1 = split ("\t", $file3[$c]);
	@pos2 = split ("\t", $file3[$cc]);
	if ($pos2[1] =~ /.+/){		#################################
		$clusters .= "Cluster number ".$cc." = \t".$pos1[2]."\t".$pos2[1]."\n";
		$c++; $cc++;}
		}
print OUT ("$clusters");






