#!/usr/bin/perl -w
# embl2fasta - perl script that extracts the nucleotide sequence from an .embl file.
#
# Written by: Yam, Ihh.
# Copyright  1999-2009 The ViewCVS Group. All rights reserved.
#By using ViewVC, you agree to the terms and conditions set forth below:
#Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#1.Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#2.Redistributions in binary form must reproduce the above copyright notice, this list of conditions 
#and the following disclaimer in the documentation and/or other materials provided with the distribution.
#THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
#THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS 
#BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
#SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
#WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
#EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#
#Usage = ./parsetranspo.pl myinput.transposase.out myinput.faa > myoutput

my %product;
open (IN, $ARGV[0]);
while ($file = <IN>)	{
	if ($file =~ m/^Description: /){
		$hit_product = $file; $hit_product =~ s/Description\: //g; chomp $hit_product;
					}
	elsif ($file =~ m/^    E-value/)	{
		$file = <IN>; $file = <IN>;
		while ($file =~ m/    [0-9]/)	{
			@file2 = split (/[ ]+/, $file);
			$locus_tag = $file2[9];
			if ($file2[4] <= 0.0001) {$product->{$locus_tag}= $hit_product;}
			$file = <IN>;
						}
					}
			}
open (IN2, $ARGV[1]);
while ($file3 = <IN2>)	{
	if ($file3 =~ m/^\>/){
		@info = split (/ /, $file3);
		$info[0] =~ s/\>//g;
		if (! $product->{$info[0]}){print $info[0]."\t".' ***** No hits found ******'."\n";}
		else {print $info[0]."\t".$product->{$info[0]}."\n";}
				}
			}
